/*
 * CG Madness - a Marble Madness clone
 * Copyright (C) 2007  Sven Reinck <sreinck@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef Server_hpp
#define Server_hpp

#include "Network.hpp"

#include "MessageDispatcher.hpp"

#include "thread/BlockingQueue.hpp"
#include "thread/BooleanCondition.hpp"

#include "libgrapple/grapple.h"

class Server : public Network
{
public:
  Server(const char* progName, const char* progVersion, MessageDispatcher* dispatcher, BooleanCondition* running);
  virtual ~Server();

  void loopMessages();

  void send(const ByteArray& package, grapple_user user);

private:
	grapple_server mServer;

	MessageDispatcher* mDispatcher;
	BooleanCondition* mRunning;

	BlockingQueue<grapple_message*> mMessages;

	void callback(grapple_message* message);

  void processMessage(grapple_message* message);

	friend int server_callback(grapple_message* message, void* context);

};

#endif
